"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fileExists_1 = require("lib/fileExists");
const Nil_1 = require("types/Nil");
const Answer_1 = require("types/Answer");
const path = require('path');
class WrappedDiskFile {
    constructor(relativePath, cwd) {
        this.path = path.resolve(cwd, relativePath);
        this.cwd = cwd;
    }
    exists(done) {
        if (this.path == Nil_1.nil) {
            done(Nil_1.nil, Answer_1.Answer.No);
        }
        else {
            fileExists_1.fileExists(done, this.path);
        }
    }
}
function file(path, cwd = __dirname) {
    return new WrappedDiskFile(path, cwd);
}
exports.file = file;
