"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fileExists_1 = require("lib/fileExists");
const Answer_1 = require("types/Answer");
const Nil_1 = require("types/Nil");
const execa = require('execa'); // fancy child_process
const Listr = require('listr'); // fancy CLI todo list
function checkSubmodules() {
    return execa.stdout('cat', ['.gitmodules'])
        .then(data => {
        let submodules = data.split("\n")
            .filter(line => /path = /.test(line.trim()))
            .map(line => line.trim().replace(/^path = /, ''));
        let tasks = submodules.map(submodule => {
            return {
                title: submodule,
                task(ctx, task) {
                    return new Promise((done, fail) => {
                        fileExists_1.fileExists((err, answer) => {
                            if (err == Nil_1.nil) {
                                if (answer == Answer_1.Answer.Yes) {
                                    done(true);
                                }
                                else {
                                    fail(new Error(`${submodule} not initalized`));
                                }
                            }
                            else {
                                fail(err);
                            }
                        }, `${submodule}/.git`);
                    });
                }
            };
        });
        return new Listr(tasks, { concurrent: true, exitOnError: false });
    });
}
module.exports = {
    title: 'verify submodule status',
    task: checkSubmodules
};
