"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const each_1 = require("lib/each");
const fileExists_1 = require("lib/fileExists");
const Answer_1 = require("types/Answer");
module.exports = {
    title: 'mandatory files present',
    task() {
        const mandatoryFiles = [
            'README.md',
            'CHANGELOG.md',
            '.editorconfig'
        ];
        each_1.each(mandatoryFiles, file => {
            return new Promise((done, fail) => {
                fileExists_1.fileExists((err, answer) => {
                    if (answer == Answer_1.Answer.Yes) {
                        done();
                    }
                    else {
                        fail(new Error(`Missing ${file}`));
                    }
                }, file);
            });
        });
    }
};
