"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const each_1 = require("lib/each");
const fileExists_1 = require("lib/fileExists");
const Answer_1 = require("types/Answer");
const fs = require('fs');
module.exports = {
    title: 'deps installed',
    task() {
        let pkg = JSON.parse(fs.readFileSync('package.json').toString());
        let promises = [];
        promises.push(new Promise((done, fail) => {
            fileExists_1.fileExists((err, answer) => {
                if (answer == Answer_1.Answer.Yes) {
                    done();
                }
                else {
                    fail(new Error(`NPM modules not installed`));
                }
            }, `node_modules`);
        }));
        promises.push(new Promise((done, fail) => {
            fileExists_1.fileExists((err, answer) => {
                if (answer == Answer_1.Answer.Yes) {
                    done();
                }
                else {
                    fail(new Error(`Missing yarn.lock file`));
                }
            }, `yarn.lock`);
        }));
        each_1.each(pkg.dependencies, (version, moduleName) => {
            promises.push(new Promise((done, fail) => {
                fileExists_1.fileExists((err, answer) => {
                    if (answer == Answer_1.Answer.Yes) {
                        done();
                    }
                    else {
                        fail(new Error(`Missing ${moduleName}`));
                    }
                }, `node_modules/${moduleName}`);
            }));
        });
        each_1.each(pkg.devDependencies, (version, moduleName) => {
            promises.push(new Promise((done, fail) => {
                fileExists_1.fileExists((err, answer) => {
                    if (answer == Answer_1.Answer.Yes) {
                        done();
                    }
                    else {
                        fail(new Error(`Missing ${moduleName}`));
                    }
                }, `node_modules/${moduleName}`);
            }));
        });
        return Promise.all(promises);
    }
};
