"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const each_1 = require("lib/each");
const fileExists_1 = require("lib/fileExists");
const Answer_1 = require("types/Answer");
const fs = require('fs');
module.exports = {
    title: 'deps installed',
    task(ctx, task) {
        let pkg = JSON.parse(fs.readFileSync('composer.json').toString());
        let promises = [];
        const vendorDir = pkg.config && pkg.config['vendor-dir'] ? pkg.config['vendor-dir'] : 'vendor';
        promises.push(new Promise((done, fail) => {
            fileExists_1.fileExists((err, answer) => {
                if (answer == Answer_1.Answer.Yes) {
                    done();
                }
                else {
                    fail(new Error(`NPM modules not installed`));
                }
            }, vendorDir);
        }));
        promises.push(new Promise((done, fail) => {
            fileExists_1.fileExists((err, answer) => {
                if (answer == Answer_1.Answer.Yes) {
                    done();
                }
                else {
                    fail(new Error(`Missing composer.lock file`));
                }
            }, `composer.lock`);
        }));
        each_1.each(pkg.require, (version, moduleName) => {
            if (moduleName != 'php') {
                promises.push(new Promise((done, fail) => {
                    fileExists_1.fileExists((err, answer) => {
                        if (answer == Answer_1.Answer.Yes) {
                            done();
                        }
                        else {
                            fail(new Error(`Missing ${moduleName}`));
                        }
                    }, `${vendorDir}/${moduleName}`);
                }));
            }
        });
        return Promise.all(promises);
    }
};
