import { fileExists } from "lib/fileExists";
import { nil } from "types/Nil";
import { Return } from "types/Return";
import { Answer } from "types/Answer";

const path = require('path');

class WrappedDiskFile {

	path: string
	cwd: string

	constructor(relativePath: string, cwd: string) {
		this.path = path.resolve(cwd, relativePath);
		this.cwd = cwd;
	}

	exists(done: Return<Answer>) {
		if (this.path == nil) {
			done(nil, Answer.No);
		}
		else { // check if file exists
			fileExists(done, this.path);
		}
	}
}

export function file(path: string, cwd = __dirname) {
	return new WrappedDiskFile(path, cwd);
}
