import { Return } from "types/Return";
import { Answer } from "types/Answer";
import { nil } from "types/Nil";
const IsThere = require('is-there');
const fs = require('fs');

////////////////////////////////////////////////////////////////////////////////

function fileExistsCheck(done: Return<Answer>, exists: boolean) {
	if (exists == true) {
		done(nil, Answer.Yes);
	}
	else { // doens't exist
		done(nil, Answer.No);
	}
}

export function fileExists(done: Return<Answer>, path: string): void {
	IsThere(path, fileExistsCheck.bind(nil, done))
}

export function fileExistsSync(path) {
	return fs.existsSync(path);
}

export default fileExists;
