import { Problem } from "types/Problem";
import { nil } from "types/Nil";
import { diag } from "diagnosis";
const figlet = require('figlet');
const minimist = require('minimist');

////////////////////////////////////////////////////////////////////////////////

const args = minimist(process.argv.slice(2));

figlet(' envctl', {
	// font: 'Isometric1'
	// font: 'Slant Relief'
	font: 'ANSI Shadow'
}, function done(err: Problem, text: string) {
	if (err == nil) {
		console.log();
		console.log(text);
		console.log();
		diag(args);
	}
	else { // got error
		console.error('Oops. Something went wrong.');
		console.dir(err);
	}
});

