import { each } from "lib/each";
import { fileExists } from "lib/fileExists";
import { Answer } from "types/Answer";

module.exports = {
	title: 'all mandatory files present',
	task() {

		const mandatoryFiles = [
			'.gitattributes',
			'.gitignore'
		];

		each(mandatoryFiles, file => {
			return new Promise((done, fail) => {
				fileExists((err, answer) => {
					if (answer == Answer.Yes) {
						done();
					}
					else {
						fail(new Error(`Missing ${file}`));
					}
				}, file)
			})
		});
	}
}