import { each } from "lib/each";

const execa = require('execa'); // fancy child_process

module.exports = {
	title: 'global deps installed',
	task() {
		return execa.stdout('npm', [ 'list', '-g', '--depth=0' ])
			.then(moduleList => {
				const cwd = process.cwd();
				const conf = require(`${cwd}/.envctl.conf.js`);

				if (conf.npm && conf.npm.globals) {
					return new Promise((done, fail) => {
						let failed = false;
						each(conf.npm.globals, entry => {
							if ( ! failed && moduleList.indexOf(entry) == -1) {
								failed = true;
								fail(new Error(`Missing global dep ${entry}`));
							}
						})

						if ( ! failed) {
							done();
						}
					})
				}
				else {
					return Promise.resolve();
				}

			}, err => {
				return Promise.reject(new Error("Your global deps appear to have errors in them."));
			})
	}
}